<?php
//includes
include('functions/pagination.php');
include('functions/slides-meta.php');

//Use Google JS Library

function ultra_scripts_function() {
	//enqueue jQuery
	wp_enqueue_script('jquery');
	
	// Site wide js+
	wp_enqueue_script('superfish', get_template_directory_uri() . '/js/superfish.js', array('jquery'), '', false);
	wp_enqueue_script('nivo', get_template_directory_uri() . '/js/jquery.nivo.slider.pack.js', array('jquery'), '', false);
}

add_action('wp_enqueue_scripts','ultra_scripts_function');

//Include JS Scripts Into WP Header Hook

//Remove WordPress Version For Security Reasons
remove_action('wp_head', 'wp_generator');

// Limit Post Word Count
function new_excerpt_length($length) {
	return 30;
}
add_filter('excerpt_length', 'new_excerpt_length');

//Replace Excerpt Link
function new_excerpt_more($more) {
       global $post;
	return '... <a class="entry-read-more" href="'. get_permalink($post->ID) . '">Read more &raquo;</a>';
}
add_filter('excerpt_more', 'new_excerpt_more');

//Activate post-image functionality (WP 2.9+)
if ( function_exists( 'add_theme_support' ) ) {
add_theme_support( 'post-thumbnails' );
}

// featured image sizes
if ( function_exists( 'add_image_size' ) ) {
add_image_size( 'full-size',  9999, 9999, false );
add_image_size( 'ultra-slider-image',  624, 333, true );
add_image_size( 'home-box-image',  280, 160, true );
add_image_size( 'portfolio-image',  280, 160, true );
add_image_size( 'blog-image',  140, 140, true );
}

// Enable Custom Background
add_custom_background();

// Define Post Types
add_action( 'init', 'create_post_type' );
function create_post_type() {
  register_post_type( 'slides',
    array(
      'labels' => array(
        'name' => __( 'Slides' ),
        'singular_name' => __( 'Slides' )
      ),
      'public' => true,
	  'supports' => array('title','thumbnail'),

    )
  );
   register_post_type( 'portfolio',
    array(
      'labels' => array(
        'name' => __( 'Portfolio' ),
        'singular_name' => __( 'Portfolio' )
      ),
      'public' => true,
	  'supports' => array('title','editor','thumbnail')

    )
  );
  register_post_type( 'home_text',
    array(
      'labels' => array(
        'name' => __( 'Homepage Text' ),
        'singular_name' => __( 'Homepage Text' )
      ),
      'public' => true,
	  'supports' => array('title','editor')

    )
  );
  register_post_type( 'home_boxes',
    array(
      'labels' => array(
        'name' => __( 'Homepage Boxes' ),
        'singular_name' => __( 'Homepage Boxes' )
      ),
      'public' => true,
	  'supports' => array('title','editor','thumbnail')

    )
  );
}

// Register Navigation Menus
register_nav_menus(
	array(
	'primary'=>__('Primary Menu'),
	)
);

/// add home link to menu
function home_page_menu_args( $args ) {
$args['show_home'] = true;
return $args;
}
add_filter( 'wp_page_menu_args', 'home_page_menu_args' );

// menu fallback
function default_menu() {
	require (TEMPLATEPATH . '/includes/default-menu.php');
}

//Register Sidebars
if ( function_exists('register_sidebar') )
register_sidebar(array(
'name' => 'Sidebar',
'description' => 'Widgets in this area will be shown in the sidebar.',
'before_widget' => '<div class="sidebar-right-box">',
'after_widget' => '</div>',
'before_title' => '<h4>',
'after_title' => '</h4>',
));

//Register Sidebars
if ( function_exists('register_sidebar') )
register_sidebar(array(
'name' => 'Footerbar',
'description' => 'Widgets in this area will be shown in the footer.',
'before_widget' => '<div class="footerbox">',
'after_widget' => '</div>',
'before_title' => '<h4>',
'after_title' => '</h4>',
));

// Get Post Categories
$categories = get_categories('hide_empty=0&orderby=name');
$wp_cats = array();
foreach ($categories as $category_list ) {
       $wp_cats[$category_list->cat_ID] = $category_list->cat_name;
}
array_unshift($wp_cats, "Choose a category");

// Start Admin Panel
$themename = "Theme Panel";
$shortname = "xs";

// Theme Options
$options = array (
array( "name" => $themename." Options",
	"type" => "title"),
array( "name" => "Main",
	"type" => "section"),
array( "type" => "open"),

array( "name" => "Custom Favicon",
	"desc" => "A favicon is a 16x16 pixel icon that represents your site; paste the URL to a .ico image that you want to use as the image",
	"id" => $shortname."_favicon",
	"type" => "text",
	"std" => get_bloginfo('url') ."/favicon.ico"),
	
array( "name" => "URL To Custom Logo",
	"desc" => "Add a URL here to exchange the site title & description for a custom logo image",
	"id" => $shortname."_custom_logo",
	"type" => "text",
	"std" => ""),

array( "name" => "Phone Number",
	"desc" => "Enter the text for your phone number section",
	"id" => $shortname."_phone",
	"type" => "text",
	"std" => ""),

array( "type" => "close"),
array( "name" => "Turn Stuff Off",
	"type" => "section"),
array( "type" => "open"),

array( "name" => "Disable Search Bar",
	"desc" => "Check this box to disable the search bar next to the navigation bar - more room for links.",
	"id" => $shortname."_disable_seach_bar",
	"type" => "checkbox",
	"std" => "false"),
	
array( "name" => "Disable Entry Meta",
	"desc" => "Disables the meta data on post entries.",
	"id" => $shortname."_disable_entry_meta",
	"type" => "checkbox",
	"std" => "false"),
	
array( "name" => "Disable Post Meta",
	"desc" => "Disables the meta data on single posts.",
	"id" => $shortname."_disable_post_meta",
	"type" => "checkbox",
	"std" => "false"),
	
array( "name" => "Disable Posts Navigation",
	"desc" => "Disables the posts navigation to the previous and next post on single posts",
	"id" => $shortname."_disable_post_navigation",
	"type" => "checkbox",
	"std" => "false"),

array( "type" => "close"),
array( "name" => "Image Slider",
	"type" => "section"),
array( "type" => "open"),

array( "name" => "Disable Slider",
	"desc" => "Check this box to disable the image slider on the homepage.",
	"id" => $shortname."_disable_slider",
	"type" => "checkbox",
	"std" => "false"),

array( "name" => "Disable Slider Links",
	"desc" => "Disable the links from the slider to their corresponding posts.",
	"id" => $shortname."_disable_slider_links",
	"type" => "checkbox",
	"std" => "false"),

array( "name" => "Pause Time",
	"desc" => "Choose the amount of time in milliseconds between each slide",
	"id" => $shortname."_slider_pause",
	"type" => "text",
	"std" => "2000"),

array( "name" => "Slider Speed",
	"desc" => "Choose the transition speed in milliseconds for your slider",
	"id" => $shortname."_slider_speed",
	"type" => "text",
	"std" => "500"),
	
array( "name" => "Animation",
	"desc" => "Choose an animation for your slider",
	"id" => $shortname."_slider_animation",
	"type" => "select",
	"options" => array("random", "slideInLeft", "fade", "fold", "slideInRight",  "sliceDown", "sliceDownLeft", "sliceUp", "sliceUpLeft", "sliceUpDown","sliceUpDownLeft", "slideInRight"),
	"std" => "random"),
	
array( "name" => "Slider Slices",
	"desc" => "Choose number of slices for the slider animation",
	"id" => $shortname."_slider_slices",
	"type" => "text",
	"std" => "15"),
	
array( "type" => "close"),
array( "name" => "Social",
	"type" => "section"),
array( "type" => "open"),
	
array( "name" => "Disable Social Links",
	"desc" => "Check this box if you would like to disable the social links in the footer",
	"id" => $shortname."_disable_social_links",
	"type" => "checkbox",
	"std" => "false"),
	
array( "name" => "Twitter ID",
	"desc" => "Enter your twitter ID for the footer link",
	"id" => $shortname."_twitter",
	"type" => "text",
	"std" => "wpexplorer"),
	
array( "name" => "Facebook Page URL",
	"desc" => "Enter your Facebook page URL for the footer link",
	"id" => $shortname."_facebook",
	"type" => "text",
	"std" => ""),
	
array( "name" => "RSS Feed URL",
	"desc" => "Enter your RSS URL for your footer link",
	"id" => $shortname."_feed",
	"type" => "text",
	"std" => "http://www.wpexplorer.com/feed"),

array( "type" => "close"),
array( "name" => "Analytics",
	"type" => "section"),
array( "type" => "open"),

array( "name" => "Google Analytics Code",
	"desc" => "You can paste your Google Analytics or other tracking code in this box. This will be automatically added to the header.",
	"id" => $shortname."_ga_code",
	"type" => "textarea",
	"std" => ""),
	
array( "type" => "close")
);


// Define Admin Panel
function mytheme_add_admin() {
global $themename, $shortname, $options;
if ( $_GET['page'] == basename(__FILE__) ) {
	if ( 'save' == $_REQUEST['action'] ) {
		foreach ($options as $value) {
		update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }
foreach ($options as $value) {
	if( isset( $_REQUEST[ $value['id'] ] ) ) { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } else { delete_option( $value['id'] ); } }
	header("Location: admin.php?page=functions.php&saved=true");
die;
}
else if( 'reset' == $_REQUEST['action'] ) {
	foreach ($options as $value) {
		delete_option( $value['id'] ); }
	header("Location: admin.php?page=functions.php&reset=true");
die;
}
}
add_menu_page($themename, $themename, 'administrator', basename(__FILE__), 'mytheme_admin');
}


//Get Javascriot and CSS files
function mytheme_add_init() {
$file_dir=get_bloginfo('template_directory');
wp_enqueue_style("functions", $file_dir."/functions/xspanel.css", false, "1.0", "all");
wp_enqueue_script("rm_script", $file_dir."/js/rm_script.js", false, "1.0");

}
function mytheme_admin() {

global $themename, $shortname, $options;
$i=0;
if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings saved.</strong></p></div>';
if ( $_REQUEST['reset'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings reset.</strong></p></div>';
?>

<div class="wrap rm_wrap">
<h2>Theme Settings</h2>
<div class="rm_opts">
<form method="post">
  <?php foreach ($options as $value) { switch ( $value['type'] ) { case "open": ?>
  <?php break; case "close": ?>
  
  </div>
  </div>
  <br />

<?php break; case "title": ?>
<?php break; case 'text': ?>

<div class="rm_input rm_text">
	<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
 	<input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_option( $value['id'] ) != "") { echo stripslashes(get_option( $value['id'])  ); } else { echo $value['std']; } ?>" />
	<small><?php echo $value['desc']; ?></small>
	<div class="clearfix"></div>
</div><!-- /rm_input rm_text -->
 
<?php break; case 'textarea': ?>

<div class="rm_input rm_textarea">
	<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
	<textarea name="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" cols="" rows=""><?php if ( get_option( $value['id'] ) != "") { echo stripslashes(get_option( $value['id']) ); } else { echo $value['std']; } ?></textarea>
	<small><?php echo $value['desc']; ?></small>
	<div class="clearfix"></div>
</div><!-- /rm_input rm_textarea -->

<?php break; case 'select': ?>

<div class="rm_input rm_select">
	<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
	<select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
	<?php foreach ($value['options'] as $option) { ?>
	<option <?php if (get_option( $value['id'] ) == $option) { echo 'selected="selected"'; } ?>><?php echo $option; ?></option><?php } ?>
	</select>
	<small><?php echo $value['desc']; ?></small>
	<div class="clearfix"></div>
</div><!-- /rm_input rm_select -->

<?php break; case "checkbox": ?>

<div class="rm_input rm_checkbox">
	<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
	<?php if(get_option($value['id'])){ $checked = "checked=\"checked\""; }else{ $checked = "";} ?>
	<input type="checkbox" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" value="true" <?php echo $checked; ?> />
	<small><?php echo $value['desc']; ?></small>
    <div class="clearfix"></div>
</div><!-- /rm_input rm_checkbox -->

<?php break; case "section": $i++ ?>

<div class="rm_section">
<div class="rm_title">
	<h3><img src="" class="inactive" alt="""><?php echo $value['name']; ?></h3>
	<span class="submit"><input name="save<?php echo $i; ?>" type="submit" value="Save changes" /></span><div class="clearfix"></div>
</div>

<div class="rm_options">
<?php break;
}
}
?>
<h3 style="color: #F00;">Reset Theme Panel</h3>
<p>Use with causion - this button will reset your theme panel options to the default settings</p>
<input type="hidden" name="action" value="save" />
</form>
<form method="post">
<p class="submit">
<input name="reset" type="submit" value="Reset" />
<input type="hidden" name="action" value="reset" />
</p>
</form>
<?php
}
?>
<?php
add_action('admin_init', 'mytheme_add_init');
add_action('admin_menu', 'mytheme_add_admin');
?>